%set_verify_elf_method unresolved=relaxed
%define _libexecdir /usr/libexec

%def_disable debug
%def_enable mysql
%def_enable pgsql
%def_enable sqlite
%def_enable db
%def_enable ldap
%def_enable pam
%def_enable pipe
%def_enable anon
%def_enable fs
%def_disable oracle # libs not present in sisyphus

Name: jabberd2
Version: 2.1.4
Release: alt2

Summary: Jabber IM server 2nd version
Group: System/Servers
License: GPL
Url: http://jabberd2.xiaoka.com/
Packager: Alexey Sidorov <alexsid@altlinux.ru>

Source: http://ftp.xiaoka.com/jabberd2/releases/jabberd-%version.tar.bz2
Source1: jabberd-alt-configdir.tar
Source2: jabberd.cfg
Source3: jabberd2-init_d.tar
Source4: db-setup.utf8.mysql
Source5: db-update-vcard.mysql
Source6: jabber2_README.ALT.KOI8-R
Source7: jabberd2.jabber-config

Patch1: jabberd2-alt-storage-auth-modules.patch
Patch2: jabberd2-alt-jabberd_in.patch
Patch3: jabberd2-alt-sysconf.patch
Patch4: jabberd2.1-alt-libdir.patch
Patch5: jabberd2-alt-localstatedir.patch
Patch6: jabberd-2.0s11.include_pgsql.patch
Patch7: jabberd-2.1.4-small-error.patch

BuildPreReq: jabber-common
BuildRequires: libidn-devel >= 0.3.0 libssl-devel >= 0.9.6b libexpat-devel libsasl2-devel
Requires: jabber-common >= 0.2 su coreutils
Obsoletes: jabberd2-router

%if_enabled mysql
BuildRequires: libMySQL-devel
%endif

%if_enabled pgsql
BuildRequires: postgresql-devel
%endif

%if_enabled sqlite
BuildRequires: libsqlite3-devel
%endif

%if_enabled db
BuildRequires: libdb4.4-devel
%endif

%if_enabled ldap
BuildRequires: libldap-devel >= 2.1.0
%endif

%if_enabled pam
BuildRequires: libpam0-devel
%endif

%package resolver
Summary: Resolver package for jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%package s2s
Summary: Server to Server package for jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release

%package c2s
Summary: Client to Server package for jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
Obsoletes: %name-pipe %name-anon %name-db

%package sm
Summary: Session Manager package for jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
Obsoletes: %name-fs %name-db

%package full
Summary: Full version of Jabberd2 (virtual package)
Summary(ru_RU.KOI8-R):   Jabberd2 ( )
License: GPL
Group: System/Servers
Requires: %name = %version-%release
Requires: %name-resolver %name-s2s %name-c2s %name-sm 

%if_enabled mysql
%package mysql
Summary: MySQL storage/auth driver for Jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
%endif

%if_enabled pgsql
%package pgsql
Summary: PgSQL storage/auth driver for Jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
%endif

%if_enabled sqlite
%package sqlite
Summary: SQLite storage/auth driver for Jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
%endif

%if_enabled ldap
%package ldap
Summary: LDAP auth driver for Jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
%endif

%if_enabled pam
%package pam
Summary: PAM auth driver for Jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
%endif

%if_enabled oracle
%package oracle
Summary: Oracle(tm) storage driver for Jabberd2
License: GPL
Group: System/Servers
Requires: %name = %version-%release
%endif

%description
This is jabberd2 server.
Included router service for jabberd.
This service is act as router between other services.

NOTE: Each other service authenticated with user/password pair,
which is jabberd/secret by default.
You MUST change this to secure user/pass pair.

%description resolver
Resolver service for jabberd.
This service resolve external DNS entries.

For example: this done for DNS SRV record in S2S service.

%description s2s
Server to Server service for jabberd.
This service is for connection you jabber server with another,
for data exchange and external roster entries.
This service uses resolver service.

%description c2s
Client to Server service for jabberd.
This service is for connection between Jabber protocol client and your server.
Authentication done by this service.
Anon, pipe, and db auth modules included.
You can install additional auth driver (See README.ALT-ru_RU.KOI8-R)

%description sm
Session Manager service for jabberd.
This service manages client sessions (last logout, roster and other)
Fs and db storage modules included.
You can install additional storage driver (See README.ALT-ru_RU.KOI8-R)

%description full
Full installation of jabberd2 (virtual package).

%if_enabled mysql
%description mysql
MySQL auth and storage module for Jabberd.

%endif

%if_enabled pgsql
%description pgsql
PgSQL auth and storage module for Jabberd.
%endif

%if_enabled sqlite
%description sqlite
SQLite auth and storage module for Jabberd.
%endif

%if_enabled ldap
%description ldap
LDAP auth and storage module for Jabberd.
%endif

%if_enabled pam
%description pam
PAM auth module for Jabberd.
%endif

%if_enabled oracle
%description oracle
Oracle auth and storage module for Jabberd.
%endif

%prep
%setup -q -n jabberd-%version

# separate storage and authreg modules
%patch1 -p1

# include supporting for jabberd wrapper
%patch2 -p1

# sysconfdir is %_sysconfdir/jabberd2
#set db drivers by default
%patch3 -p1

# s2s, sm, c2s, router, resolver and other stored in %_libexecdir/jabberd2
# move mod_*.so %_libdir/jabberd ->%_libdir/jabberd2
%patch4 -p1

# using /var/lib/jabberd2 instead of /var/lib/jabberd
%patch5 -p1

#search pgsql headers in /usr/include/pgsql directory
%patch6 -p1

#this patch correct small stupid typing error in source
%patch7 -p1

#this required for jabberd2-alt-storage-auth-modules.patch
mv c2s/authreg_anon.c modules/anon/authreg_anon.c
mv c2s/authreg_db.c modules/db/authreg_db.c
mv c2s/authreg_ldap.c modules/ldap/authreg_ldap.c
mv c2s/authreg_mysql.c modules/mysql/authreg_mysql.c
mv c2s/authreg_pam.c modules/pam/authreg_pam.c
mv c2s/authreg_pgsql.c modules/pgsql/authreg_pgsql.c
mv c2s/authreg_pipe.c modules/pipe/authreg_pipe.c
mv c2s/authreg_sqlite.c modules/sqlite/authreg_sqlite.c

mv sm/storage_db.c modules/db/storage_db.c
mv sm/storage_fs.c modules/fs/storage_fs.c
mv sm/storage_mysql.c modules/mysql/storage_mysql.c
mv sm/storage_oracle.c modules/oracle/storage_oracle.c
mv sm/storage_pgsql.c modules/pgsql/storage_pgsql.c
mv sm/storage_sqlite.c modules/sqlite/storage_sqlite.c

%build
autoreconf -fisv

%configure --enable-ssl \
	%{subst_enable debug} \
	%{subst_enable mysql} \
	%{subst_enable pgsql} \
	%{subst_enable sqlite} \
	%{subst_enable db} \
	%{subst_enable ldap} \
	%{subst_enable pam} \
	%{subst_enable pipe} \
	%{subst_enable anon} \
	%{subst_enable fs} \
	%{subst_enable oracle}
%make_build

%install
%make install DESTDIR=%buildroot

mkdir -p %buildroot{%_docdir/%name-%version,%_jabber_server_dir}
install -m 0644 %SOURCE4 db-setup.utf8.mysql
install -m 0644 %SOURCE5 db-update-vcard.mysql
install -m 0644 %SOURCE6 README.ALT-ru_RU.KOI8-R
install %SOURCE7 %buildroot%_jabber_server_dir/jabberd2

# delete the dist files of the configs
rm -f %buildroot/%_sysconfdir/%name/*.xml.dist
rm -f %buildroot/%_sysconfdir/%name/templates/*.xml.dist

# delete perl wrapper script's default config
rm -f %buildroot/%_sysconfdir/%name/jabberd.cfg*

# delete perl wrapper script's man page
rm -f %buildroot/%_man8dir/jabberd.8

# delete perl wrapper script lastly
rm -f %buildroot/%_bindir/jabberd

tar -xf %SOURCE1 -C %buildroot%_sysconfdir/%name
rm -f %buildroot%_sysconfdir/%name/jabber.cfg
install -m 0640 %SOURCE2 %buildroot%_sysconfdir/%name/

mkdir -p %buildroot%_localstatedir/jabberd2/{pid,spool,log,syslogs,db}
mkdir -p %buildroot%_var/run
ln -s $(relative %_localstatedir/jabberd2/pid %_var/run/%name) %buildroot%_var/run/%name

mkdir -p %buildroot%_initdir
tar -xf %SOURCE3 -C %buildroot%_initdir

%pre
%_sbindir/groupadd -r -f jabberd2 \
    2>/dev/null ||:

%_sbindir/useradd -r -g jabberd2 -c 'Jabber2 server' \
	-d %_localstatedir/jabberd2 -s /dev/null jabberd2 2>/dev/null ||:

%post
%_jabber_config
if [ $1 -eq 1 ]; then
	/sbin/chkconfig --add %name
fi
if [ $1 -eq 2 ]; then
	/sbin/service %name condrestart ||:
fi

%preun
%preun_service %name-router
if [ $1 -eq 0 ]; then
	/sbin/chkconfig --del %name ||:
fi

#post router
#post_service %name-router
#%_jabber_config
#if [ $1 -eq 2 ]; then
#	/sbin/service %name condrestart ||:
#fi

#preun router
#preun_service %name-router

%post resolver
%post_service %name-resolver

%preun resolver
%preun_service %name-resolver

%post sm
%post_service %name-sm

%preun sm
%preun_service %name-sm

%post s2s
%post_service %name-s2s

%preun s2s
%preun_service %name-s2s

%post c2s
%post_service %name-c2s

%preun c2s
%preun_service %name-c2s

%files
%dir %_sysconfdir/%name
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/jabberd.cfg
%dir %_sysconfdir/%name/cfg.d
%doc %_docdir/*
%doc README ChangeLog NEWS AUTHORS COPYING PROTOCOL BUGS INSTALL TODO
%doc tools/db* tools/*.pl tools/jabberd man/jabberd.8
%doc db-setup.utf8.mysql db-update-vcard.mysql README.ALT-ru_RU.KOI8-R
%doc %_man8dir/*

%_initdir/%name
%dir %_libexecdir/%name
%dir %_localstatedir/jabberd2
%attr(2770,root,jabberd2) %dir %_localstatedir/jabberd2/*
%_var/run/jabberd2

#files router
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/cfg.d/01router.cfg
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/router.xml
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/router-users.xml
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/router-filter.xml
%_libexecdir/%name/router
%_initdir/%name-router
%_jabber_server_dir/jabberd2

%files resolver
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/cfg.d/*resolver*
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/resolver.xml
%_libexecdir/%name/resolver
%_initdir/%name-resolver

%files s2s
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/cfg.d/*s2s*
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/s2s.xml
%_libexecdir/%name/s2s
%_initdir/%name-s2s

%files c2s
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/cfg.d/*c2s*
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/c2s.xml
%_libexecdir/%name/c2s
%_initdir/%name-c2s
%if_enabled pipe
%_libdir/%name/*pipe.so*
%endif
%if_enabled anon
%_libdir/%name/*anon.so*
%endif
%if_enabled db
%_libdir/%name/authreg_db.so
%endif


%files sm
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/cfg.d/*sm*
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/sm.xml
%dir %_sysconfdir/%name/templates
%attr(0640,root,jabberd2) %config(noreplace) %_sysconfdir/%name/templates/*.xml
%_libexecdir/%name/sm
%_initdir/%name-sm
%_libdir/%name/mod_*.so*
%if_enabled fs
%_libdir/%name/*fs.so*
%endif
%if_enabled db
%_libdir/%name/storage_db.so
%endif

%exclude %_libdir/%name/*.la

%files full
%if_enabled mysql
%files mysql
%_libdir/%name/*mysql.so*
%endif

%if_enabled pgsql
%files pgsql
%_libdir/%name/*pgsql.so*
%endif

%if_enabled sqlite
%files sqlite
%_libdir/%name/*sqlite.so*
%endif

%if_enabled ldap
%files ldap
%_libdir/%name/*ldap.so*
%endif

%if_enabled pam
%files pam
%_libdir/%name/*pam.so*
%endif

%if_enabled oracle
%files oracle
%_libdir/%name/*oracle.so*
%endif

%changelog
* Wed Apr 11 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.4-alt2
- Correct dynamic modules path in sm config
- Added coreutils to requires

* Mon Apr 09 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.4-alt1
- New version
- some parts of patches included by upstream
- Added patch jabberd-2.1.4-small-error.patch
- Small spec cleaning

* Sat Apr 07 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.3-alt2
- Added su to requires

* Tue Apr 03 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.3-alt1
- New version
- ALT Linux Jabber Policy package

* Thu Mar 29 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.2-alt3
- include anon,pipe,db auth drivers to c2s package, and fs,db driver to sm package.
  set db drivers by default
- include router module to main package

* Tue Mar 27 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.2-alt2
- Fixed BuildRequires for postgresql

* Wed Mar 21 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.2-alt1.1
- Small fix: auth/storage driver installation warning moved from jabberd2
  to corresponding packages (jabberd2-sm and jabberd2-c2s)

* Tue Mar 13 2007 Alexey Sidorov <alexsid@altlinux.ru> 2.1.2-alt1
- New version
- New packager
- Correct module structure for auth/storage

* Wed Dec 27 2006 Vadym Kononenko <vkonoenko@atlantic-link.com.ua> 2.1-alt0.1
- build new version

* Fri Mar 24 2006 Andrei Bulava <abulava@altlinux.ru> 2.0s11-alt1
- 2.0s11
- moved jabberd(8) (perl wrapper script's man page) to %%doc in order
  to avoid silly file conflict with jabber package

* Mon Dec 26 2005 Andrei Bulava <abulava@altlinux.ru> 2.0s10-alt2
- re-examined, cleaned up and fixed init scripts:
  + jabberd2: fixed 'restart'; implemented 'condstop' and 'condrestart';
    circuited 'reload' and 'condreload' to 'restart' and 'condrestart'
    accordingly
  + jabberd2-router: fixed 'restart'
  + jabberd2-{router,resolver,sm,s2s,c2s}: circuited 'reload' and
    'condreload' to 'restart' and 'condrestart' accordingly
- moved 'jabberd' perl wrapper script to %%doc, because it wasn't used
  to run jabberd2 components anyway
- spec fixes:
  + packaged relevant directories
  + fixed %%post and %%preun sections to provide proper behavior upon
    updates and removals of packages, though it requires unoptimum
    number of restarts

* Tue Dec 06 2005 Andrei Bulava <abulava@altlinux.ru> 2.0s10-alt1
- initial build for ALT Linux (thanks to Pavel Boldin <bp@> for good starting
  points)
- TODO: update alt-storage-modules patch or reconsider to wait for 2.1 branch

